Bug 524298 - dhcp client fails to setup route to not-on-local-net gateway in ARP-less device
dhcp client fails to setup route to not-on-local-net gateway in ARP-less device
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: dhcp (Show other bugs)
12
All Linux
low Severity medium
: ---
: ---
Assigned To: Jiri Popelka
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-09-18 14:44 EDT by inakypg
Modified: 2010-11-01 16:48 EDT (History)
0 users

See Also:
Fixed In Version: dhcp-4.2.0-12.fc14
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-11-01 16:48:13 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description inakypg 2009-09-18 14:44:06 EDT
Description of problem:

When using dhclient on certain WiMAX networks, it fails to set up local and default routes properly.

The issue is a combination of:

1 - the network DHCP server reports a default route via a gateway that is not on the local network of the wimax device

2 - the wimax device has no ARP support (it being a pure P2P link)

3 - /sbin/dhclient-script uses ARPING to determine if the gateway host is reachable or not in is_router_reachable().

When invoked, dhclient-script, in is_router_reachable, determines it is in a kind of situation 1, but then, because of 2 and 3, it fails to determine that it can actually reach the router.

Version-Release number of selected component (if applicable):

4.1.0-23.fc11

How reproducible:

Straightforward

Steps to Reproduce:
1.Try to connect to a network with said route configuration
2.Connect WiMAX, run dhclient through NM or manually
3.See it fail (check "network is unreachable" message in /var/log/messages)
  
Actual results:

Route table not setup properly with default route

Expected results:

dhclient-script recognizes the router as reachable and sets up default route.

Additional info:

The fix could be quite simple, by doing either of:

a. replace usage of arping in is_router_reachable() by ping (this is a drop in, since the command line arguments seem to be the same) -- this might not really work, so a variation is:

b. in is_router_reachable(), setup the 

        ip route add ${router}/32 dev ${interface}
        # error handling
        if ping -f -q -I ${interface} -w2 ${router}; then
            unreachable=0
        else
            unreachable=1
            logmessage "DHCP router ${router} is unreachable on DHCP subnet ${mysubnet} router subnet ${routersubnet}"
            ip route del ${router}/32 dev ${interface}
        fi
Comment 1 Bug Zapper 2010-04-28 06:27:58 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Jiri Popelka 2010-10-07 12:17:05 EDT
Fixed in dhcp-4.2.0-11.fc14, sorry for the huge delay.

http://pkgs.fedoraproject.org/gitweb/?p=dhcp.git;a=commitdiff;h=db1d0eda080ed2ccedb700eba9b7bb60c905e1ca
Comment 3 inakypg 2010-10-07 13:16:36 EDT
Thank you -- I won't be able to verify (can't upgrade my machine as of now), but the same fix you applied is the one I tried back in the day.
Comment 4 Fedora Update System 2010-10-13 07:10:54 EDT
dhcp-4.2.0-12.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/dhcp-4.2.0-12.fc14
Comment 5 Fedora Update System 2010-10-13 17:21:31 EDT
dhcp-4.2.0-12.fc14 has been pushed to the Fedora 14 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update dhcp'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/dhcp-4.2.0-12.fc14
Comment 6 Fedora Update System 2010-11-01 16:47:46 EDT
dhcp-4.2.0-12.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.